# Place available states under this node.
# Provides the mechanism for switching states.
@icon("res://state_machine/think.png")
extends Node
class_name StateMachine

@export var initial_state: NodePath
var state: Node  # Current state

# Set by owner
var state_debug_stat = null

func _ready():
	state = get_node(initial_state)

func transition(new_state, args = {}):
	StatHub.maybe_put_stat(state_debug_stat, new_state.name)
	state = new_state
	new_state.enter(args)

func _physics_process(delta):
	state.update(delta)
